import React, { forwardRef } from 'react';
import { useMatchMedia } from '@alfalab/core-components-mq/moderncssm';
import { PatternLockDesktopV1 } from './desktop/Component.desktop.js';
import { PatternLockMobileV1 } from './mobile/Component.mobile.js';

/**
 * @deprecated
 * Использует PatternLock
 */
const PatternLockV1 = forwardRef(({ breakpoint = 1024, ...restProps }, ref) => {
    const query = `(min-width: ${breakpoint}px)`;
    const [isDesktop] = useMatchMedia(query);
    const Component = isDesktop ? PatternLockDesktopV1 : PatternLockMobileV1;
    return React.createElement(Component, { ref: ref, ...restProps });
});

export { PatternLockV1 };
